Package org.apache.commons.math3.ode.sampling

# Interface StepHandler

All Known Implementing Classes:
  `ContinuousOutputModel`, `DummyStepHandler`, `StepNormalizer`

public interface StepHandler
This interface represents a handler that should be called after each successful step.

The ODE integrators compute the evolution of the state vector at some grid points that depend on their own internal algorithm. Once they have found a new grid point (possibly after having computed several evaluation of the derivative at intermediate points), they provide it to objects implementing this interface. These objects typically either ignore the intermediate steps and wait for the last one, store the points in an ephemeris, or forward them to specialized processing or output methods.

Since:
  1.2
See Also:
  - `FirstOrderIntegrator`
  - `SecondOrderIntegrator`
  - `StepInterpolator`

## Method Summary

Modifier and Type
Method
Description
`void`
`handleStep(StepInterpolator interpolator, boolean isLast)`
Handle the last accepted step
`void`
`init(double t0, double[] y0, double t)`
Initialize step handler at the start of an ODE integration.

## Method Details

### init

void init(double t0, double[] y0, double t)
Initialize step handler at the start of an ODE integration.

This method is called once at the start of the integration. It may be used by the step handler to initialize some internal data if needed.

Parameters:
  `t0` - start value of the independent time variable
  `y0` - array containing the start value of the state vector
  `t` - target time for the integration

### handleStep

void handleStep(StepInterpolator interpolator, boolean isLast) throws MaxCountExceededException
Handle the last accepted step

Parameters:
  `interpolator` - interpolator for the last accepted step. For efficiency purposes, the various integrators reuse the same object on each call, so if the instance wants to keep it across all calls (for example to provide at the end of the integration a continuous model valid throughout the integration range, as the `ContinuousOutputModel` class does), it should build a local copy using the clone method of the interpolator and store this copy. Keeping only a reference to the interpolator and reusing it will result in unpredictable behavior (potentially crashing the application).
  `isLast` - true if the step is the last one
Throws:
  `MaxCountExceededException` - if the interpolator throws one because the number of functions evaluations is exceeded